/*
 * IPSECv6 code
 * Copyright (C) 2001 Florian Heissenhuber
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * RCSID $Id: enc-cbc3des.c,v 1.1.1.1 2001/05/22 06:14:04 miyazawa Exp $
 */
 #include <linux/config.h>

#ifdef CONFIG_IPSEC_ENC_3DES	
//FH added 3DES
#include "libdes/des.h" 
#include "enc-cbc3des.h"

extern void des_ede3_cbc_encrypt(caddr_t, caddr_t, int, caddr_t, caddr_t, caddr_t, caddr_t, int);

/*FH these functions maps IPsec v6 to FreeSWAN 3DES encryption algorithm */
void enc_cbc3des_encrypt_data(char* src, int src_size, char* iv, char* key, char* dest, int dest_size) 
{
	des_ede3_cbc_encrypt(src, dest, dest_size,
			     (char*)key,
			     (char*)(key + sizeof(struct des_eks)),
			     (char*)(key + 2 * sizeof(struct des_eks)),
			     (char*)iv, 1);

	return ;
}
	
void enc_cbc3des_decrypt_data(char* src, int src_size, char* iv, char* key,char* dest, int dest_size) 
{
	des_ede3_cbc_encrypt(src, dest, dest_size,
			     (char*)key,
			     (char*)(key + sizeof(struct des_eks)),
			     (char*)(key + 2 * sizeof(struct des_eks)),
			     (char*)iv, 0);
	return ;
}

#endif //CONFIG_IPSEC_ENC_3DES	

